#include "Wire.h"
#include "WiiChuck.h"
#include <Servo.h> 

// trois variables pour chacun des servos (sens horaire, A étant en haut.
Servo servoA, servoB, servoC;

boolean modeAuto = true;


WiiChuck chuck = WiiChuck();

int valX = 0;
int valY = 0;

void setup() {

  // initialisation des servomoteurs
  servoA.attach(8);
  servoB.attach(9);
  servoC.attach(10);

  //
  Serial.begin(9600);
  chuck.begin();
  chuck.update();
}

// variables du mode automatique
int index = 0;

int vals[5][4] = {
  {
    20,20,20,2000                  }
  ,{
    90,90,90,3000                  }
  ,{
    90,20,20,2000                  }
  ,{
    20,20,90,2000                  }
  ,{
    20,90,20,2000                  }
};

long last = 0;



void loop() {
  delay(200);
  chuck.update(); 

  if (chuck.cPressed())
  {
    // petit mouvement pour montrer le changement de mode
    servoA.write(60);
    servoB.write(60);
    servoC.write(60);
    delay(200);
    servoA.write(40);
    servoB.write(40);
    servoC.write(40);
    delay(200);

    // Changement de mode
    modeAuto = !modeAuto;
    Serial.print("Mode automatique :");
    if (modeAuto) {      
      servoA.write(90);
      servoB.write(90);
      servoC.write(90);
      delay(200);
      last = millis();
    } 
    else {
      servoA.write(20);
      servoB.write(20);
      servoC.write(20);
      delay(200);
    }
    Serial.println(modeAuto);
  }

  if (modeAuto) {
    servoA.write(vals[index][0]);
    servoB.write(vals[index][1]);
    servoC.write(vals[index][2]);
    if (millis()-last > vals[index][3]) {
      last = millis();
      if (index++ > 4) {
        index = 0; 
      }
      Serial.print("Passage au n° :");
      Serial.println(index);
    }
  } 
  else {


    // lecture des valeurs du joystick 2D
    valX = chuck.readJoyX();
    valY = chuck.readJoyY();
    
    // le cerveau de calculs savants pour asservir la tete !!!
    servoA.write(map(valY,-130,130,20,90));
    servoB.write(map(valX,-130,130,20,90));
    servoC.write(map(valX,130,-130,20,90));

    // affichage
    Serial.print(valX);
    Serial.print(",");
    Serial.print(valY);
    Serial.println();
  }
}











